 <<ǽ 16-1 >> =======================================================================================================

1.   MY_XML_CLOB  ̺  , hanbit_newbook.xml    Ͽ  .

CREATE TABLE my_xml_clob (
        id        INTEGER,
        xmlclob  XMLType );


<<>> --------------------------------------------------------------------------------------------------
--  hanbit_newbook.xml  my_xml_clob ̺ ϴ  ̴. 

DECLARE
    dest_clob   CLOB := NULL;
    src_clob    BFILE  := BFILENAME('XML_TEST', 'hanbit_newbook.xml');
    dst_offset  number := 1 ;
    src_offset  number := 1 ;
    lang_ctx    number := DBMS_LOB.DEFAULT_LANG_CTX;
    warning     number;

BEGIN
    
    -- ӽ÷ CLOB Ϳ ε Ѵ.
    DBMS_LOB.createTemporary(dest_clob, true, DBMS_LOB.SESSION); 
    
    -- Է  ̹Ƿ, ش  б .
    DBMS_LOB.OPEN(src_clob, DBMS_LOB.LOB_READONLY);

    -- µ  xml_file ÷ Ѵ.
    DBMS_LOB.LoadCLOBFromFile(
                dest_clob,
                src_clob,
                DBMS_LOB.GETLENGTH(src_clob),
                dst_offset,
                src_offset,
                nls_charset_id('KO16MSWIN949'), -- ĳͼ ѱ .      
                lang_ctx,
                warning   );

    -- CLOB ȯ dest_clob ԷѴ. 
    INSERT INTO my_xml_clob (id, xmlclob) 
        VALUES(1, XMLType(dest_clob));
        
    --  ݴ´. 
    DBMS_LOB.CLOSE(src_clob);

    COMMIT;

    DBMS_OUTPUT.PUT_LINE('XML File save is succeed!');

EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);

END;

-----------------------------------------------------------------------------------------------------------

2. MY_XML_DATA  ̺  , hanbit_newbook.xml    Ͽ  .

CREATE TABLE my_xml_data  (
        id        INTEGER,
        xmldata  XMLType );

<<>> --------------------------------------------------------------------------------------------------
INSERT INTO my_xml_data 
VALUES ( 1, XMLType( BFILENAME('XML_TEST','hanbit_newbook.xml'),
                       NLS_CHARSET_ID('KO16MSWIN949')) );                      

-----------------------------------------------------------------------------------------------------------

3. MY_XML_DATA ̺  XML Ϳ      Ǿ ִ.  item ׸  ִµ, 
   å  ϴ  ۼغ. 

<<>> --------------------------------------------------------------------------------------------------
SELECT extract(XMLDATA, '/rss/channel/item/title') ext1
  FROM my_xml_data;
-----------------------------------------------------------------------------------------------------------

4. ̹  ó Ұ å  ϴ  ۼغ.  ±׸   ؾ Ѵ. 

<<>> --------------------------------------------------------------------------------------------------
SELECT extractValue(XMLDATA, '/rss/channel/item[1]/title') ext1
  FROM my_xml_data;
-----------------------------------------------------------------------------------------------------------

5. 4    å  " ٷ ϴ  2007" ϴ UPDATE  ۼ . 

<<>> --------------------------------------------------------------------------------------------------
UPDATE my_xml_data
    SET XMLDATA = updateXML( XMLDATA, 
                     '/rss/channel/item[1]/title/text()', ' ٷ ϴ  2007');

-----------------------------------------------------------------------------------------------------------

6. 4   "ȸ翡 ٷ ϴ  2007"̶ ׸ ãƳ ̸ ϴ  ۼ . 

<<>> --------------------------------------------------------------------------------------------------

SELECT existsNode(XMLDATA, '/rss/channel/item/title="ȸ翡 ٷ ϴ  2007"') 
  FROM my_xml_data;
  
SELECT extract(XMLDATA, '/rss/channel/item/title') 
  FROM my_xml_data; 
  
--   ϸ 5° å  "ȸ翡 ٷ ϴ  2007"   ִ. 
  
UPDATE my_xml_data
   SET XMLDATA = updateXML( XMLDATA, 
                            '/rss/channel/item[5]/title/text()', NULL)
WHERE existsNode(XMLDATA,'/rss/channel/item[5]/title="ȸ翡 ٷ ϴ  2007"') = 1;

-----------------------------------------------------------------------------------------------------------

 <<ǽ 16-2 >> =======================================================================================================
 
 1.    . 

SELECT a.episode_name,
       d.role_name,
       b.character_name, 
	     c.real_name	   
  FROM star_wars a,
       characters b,
	     casting c,
	     roles d
 WHERE a.episode_id = c.episode_id
   AND b.character_id = c.character_id
   AND b.role_id = d.role_id
 ORDER BY a.open_year, b.role_id, b.character_id;


EPISODE_NAME             ROLE_NAME   CHARACTER_NAME      REAL_NAME 
----------------------  -----------  ------------------  ------------ 
ο (A New Hope)             ũ ī̿Ŀ         ũ ع 
ο (A New Hope)              ɳ           ˷ ׽  
ο (A New Hope)    ý           پ ̴             ̺ ο 
ο (A New Hope)    ý           پ ̴(Ҹ)      ӽ  



    Ͽ,    XML ͷ ȯϴ  ۼ . 

<episode name="ο (A New Hope)">
  <role name = "">
     <character id="1"><chrname>ũ ī̿Ŀ</chrname><realname>ũ ع</realname>
     <character id="2"><chrname> ɳ</chrname><realname>˷ ׽</realname>
  </role>
<episode>

<<>> --------------------------------------------------------------------------------------------------
-- Ư Ǽҵ庰  

SELECT XMLELEMENT("EPISODE", 
                   XMLAttributes(max(a.episode_name) AS "name"),
                   XMLAgg(XMLElement("role", 
                                     XMLAttributes(max(d.role_name) AS "name"),
                                     XMLAgg(XMLElement("character",
                                                       XMLAttributes(b.character_id AS "id"),
                                                       XMLElement("chrname", b.character_name),
                                                       XMLElement("realname", c.real_name)))))
                  )ttt
  FROM star_wars a,
       characters b,
       casting c,
       roles d
 WHERE a.episode_id = c.episode_id
   AND b.character_id = c.character_id
   AND b.role_id = d.role_id
   AND a.episode_id = 4
 GROUP BY a.episode_name, d.role_name;

 
-- Ÿ ü Ǽҵ庰  
SELECT XMLElement("episode",
                   XMLAttributes(st.episode_name as "name"),
                   ( SELECT XMLAgg(XMLElement( "roles",
                                               XMLAttributes( rle.role_name as "name"),
			                                         (SELECT XMLAgg(XMLElement("character",
				                                                                 XMLAttributes( b.character_id as "id"),
				                                                                 XMLElement("chrname", b.character_name),
				                                                                 XMLElement("realname", c.real_name)))
				                                          FROM characters b, 
				                                               casting c
				                                         WHERE b.character_id = c.character_id
                                                   AND st.episode_id  = c.episode_id
                                                   AND rle.role_id    = b.role_id )))
                       FROM roles rle  )   
                  )
   FROM star_wars st
   
--   GROUP BY   ʰ  XMLAgg Լ Ͽ ϴ  ͸ Ѵ.    
-----------------------------------------------------------------------------------------------------------
